"use strict";

// From:
//  http://rnhart.net/articles/key-finding/

//major profile
//do	do#	re	re#	mi	fa	fa#	so	so#	la	la#	ti
//6.35	2.23	3.48	2.33	4.38	4.09	2.52	5.19	2.39	3.66	2.29	2.88

//minor profile
//la	la#	ti	do	do#	re	re#	mi	fa	fa#	so	so#
//6.33	2.68	3.52	5.38	2.60	3.53	2.54	4.75	3.98	2.69	3.34	3.17


// kh = Krumhansl

var kh_major_profile = [6.35, 2.23, 3.48, 2.33, 4.38, 4.09, 2.52, 5.19, 2.39, 3.66, 2.29, 2.88 ];

var kh_minor_profile = [6.33, 2.68, 3.52, 5.38, 2.60, 3.53, 2.54, 4.75, 3.98, 2.69, 3.34, 3.17 ];


function khCreatePairing(profile,chromatic_scale_durations,offset)
{
    var pairing = [];
    for (var p=0; p<12; p++) {
	pairing.push({"p":profile[p],"c":chromatic_scale_durations[(p+s)%12]});
    }
    

    return pairing;
}


function khCreateAllPairings(chromatic_scale_durations,major_profile,minor_profile)
{
    // chromatic_scale_durations.length = 12

    var chromatic_keys = ["C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"];

    var major_pairings = {};
    var minor_pairings = {};

    // Foreach scale
    for (var s=0; s<12; s++) {
	var scale = chromatic_keys[s];

	major_pairings[scale] = khCreatePairing(major_profile,chromatic_scale_durations,s);
	minor_pairings[scale] = khCreatePairing(minor_profile,chromatic_scale_durations,s);
    }

    return {"major" : major_pairings, "minor" : minor_pairings};

}


